#if defined _2degArm_included
  #endinput
#endif
#define _2degArm_included
#pragma library 2DEGARM

#include <float>

native SetArmLength( Float: length1 , Float: length2 );
native Kinematics ( Float: ang[] , Float: pos[]  , anglemode:mode=degrees );
native inverseKinematics ( Float: ang[] , Float: pos[] , select=1 , anglemode:mode=degrees );
native Float: CordicAtan2( Float: px , Float: py  , anglemode:mode=degrees );
native CordicCosSin( Float: angle , &Float: cos , &Float: sin , anglemode:mode=degrees ) ;
native Float: floatatan2( Float: px , Float: py  , anglemode:mode=radian );
native Float: floatatan2f( Float: px , Float: py  , anglemode:mode=radian );
native Float: floatcosf( Float: angle  , anglemode:mode=radian );
native Float: floatsinf( Float: angle  , anglemode:mode=radian );
native Float: floatsqrootf( Float: val );

/*
// ȉ̊֐gpꍇ͖{t@CCN[hOL1CL2`Ă
// Pawnł̉^wi{xj
stock Kinema( Float: ang[] , Float: pos[] ) {
	new Float: ang12 = ang[0] + ang[1];
	pos[0] = L1*floatcos( ang[0] ) + L2*floatcos( ang12 );
	pos[1] = L1*floatsin( ang[0] ) + L2*floatsin( ang12 );
}

// Pawnł̉^wiPxj
stock KinemaSingle( Float: ang[] , Float: pos[] ) {
	new Float: ang12 = ang[0] + ang[1];
	pos[0] = L1*floatcosf( ang[0] ) + L2*floatcosf( ang12 );
	pos[1] = L1*floatsinf( ang[0] ) + L2*floatsinf( ang12 );
}

// Pawnł̉^wiCORDICZj
stock Kinema_cor( Float: ang[] , Float: pos[] ) {
	new Float:C1 , Float:S1 , Float:C12 , Float:S12;
	
	CordicCosSin( ang[0] , C1 , S1 ) ;
	CordicCosSin( ang[0]+ang[1] , C12 , S12 ) ;

	pos[0] = L1*C1 + L2*C12;
	pos[1] = L1*S1 + L2*S12;
}

// Pawnł̋t^wi{xj
stock iKinema( Float: pos[] , Float: ang[] , select=1) {
	new Float: C2 , Float: S2;
	
	C2 = ( pos[0]*pos[0] + pos[1]*pos[1] - L1*L1 - L2*L2 ) / (2.0*L1*L2 );
	if( floatabs(C2) > 1.0 ) return;
	S2 = floatsqroot( 1.0 - C2*C2);
	
	switch(select){
		case 1:
		{
			ang[0] = floatatan2( pos[1] , pos[0] ) - floatatan2( L2*S2 , L1 + L2*C2 );
			ang[1] = floatatan2( S2 , C2 );
		}
		case 2:
		{
			ang[0] = floatatan2( pos[1] , pos[0] ) + floatatan2( L2*S2 , L1 + L2*C2 );
			ang[1] = floatatan2(-S2 , C2);
		}
	}
}

// Pawnł̋t^wiPxj
stock iKinemaSingle( Float: pos[] , Float: ang[] , select=1) {
	new Float: C2 , Float: S2;
	
	C2 = ( pos[0]*pos[0] + pos[1]*pos[1] - L1*L1 - L2*L2 ) / (2.0*L1*L2 );
	if( floatabs(C2) > 1.0 ) return;
	S2 = floatsqrootf( 1.0 - C2*C2);
	
	switch(select){
		case 1:
		{
			ang[0] = floatatan2f( pos[1] , pos[0] ) - floatatan2f( L2*S2 , L1 + L2*C2 );
			ang[1] = floatatan2f( S2 , C2 );
		}
		case 2:
		{
			ang[0] = floatatan2f( pos[1] , pos[0] ) + floatatan2f( L2*S2 , L1 + L2*C2 );
			ang[1] = floatatan2f(-S2 , C2);
		}
	}
}

// Pawnł̋t^wiCORDICZj
stock iKinema_cor( Float: pos[] , Float: ang[] , select=1) {
	new Float: C2 , Float: S2;
	
	C2 = ( pos[0]*pos[0] + pos[1]*pos[1] - L1*L1 - L2*L2 ) / (2.0*L1*L2 );
	if( floatabs(C2) > 1.0 ) return;
	S2 = floatsqrootf( 1.0 - C2*C2);
	
	switch(select){
		case 1:
		{
			ang[0] = CordicAtan2( pos[1] , pos[0] ) - CordicAtan2( L2*S2 , L1 + L2*C2 );
			ang[1] = CordicAtan2( S2 , C2 );
		}
		case 2:
		{
			ang[0] =CordicAtan2( pos[1] , pos[0] ) +CordicAtan2( L2*S2 , L1 + L2*C2 );
			ang[1] = CordicAtan2(-S2 , C2);
		}
	}
}
*/