#include <LM3S3748>
#include <RobotArm>

#define RC_MAX_ANGLE  144.0
#define RC_MIN_ANGLE -144.0
#define RC_NEUTRAL    4750 //(1520*25)>>3
new Float: posT[2];
new running = false , update = false;

servo_pulse(Float:angle) {
	new Float: ang;
	ang = angle;
	if( angle > RC_MAX_ANGLE )		ang = RC_MAX_ANGLE;
	else if( angle < RC_MIN_ANGLE )	ang = RC_MIN_ANGLE;
	return floatround(125.0*ang/6.0) + RC_NEUTRAL;
}

forward PORTBHandler(irq_no);
forward PORTDHandler(irq_no);

public PORTBHandler(irq_no){
	running = false;
}

public PORTDHandler(irq_no){
	if( !running ) return;
	switch ( irq_no & 0xFF) {
		case 0x10 : if( posT[1] <  50.0) posT[1] += 5.0;
		case 0x20 : if( posT[1] > -50.0) posT[1] -= 5.0;
		case 0x40 : if( posT[0] <  90.0) posT[0] += 5.0;
		case 0x80 : if( posT[0] >  50.0) posT[0] -= 5.0;
	}
	update = true;
}

main()
{
	new Float: angle[2] , Float: posA[2];
	new Float: delta1 , Float: delta2;

	PinTypeGPIOOutput( PG2 , GPIO_STRENGTH_4MA );
	PinTypeGPIOInput( PB7 );
	PinTypeGPIOInput( PD4 , GPIO_PIN_TYPE_STD );
	PinTypeGPIOInput( PD5 , GPIO_PIN_TYPE_STD );
	PinTypeGPIOInput( PD6 , GPIO_PIN_TYPE_STD );
	PinTypeGPIOInput( PD7 , GPIO_PIN_TYPE_STD );
	PinTypePWMOut( PF0 );
	PinTypePWMOut( PF1 );
	GPIOPinIntEnable( PB7 , GPIO_FALLING_EDGE );
	GPIOPinIntEnable( PD4 , GPIO_RISING_EDGE );
	GPIOPinIntEnable( PD5 , GPIO_RISING_EDGE );
	GPIOPinIntEnable( PD6 , GPIO_RISING_EDGE );
	GPIOPinIntEnable( PD7 , GPIO_RISING_EDGE );
	GPIOPortIntRegister( GPIO_PORTB , "PORTBHandler" );
	GPIOPortIntRegister( GPIO_PORTD , "PORTDHandler" );

	PWMGenPeriodSet( PWM_GEN_0 , (20000*25)>>3 );
	PWMPulseWidthSet(PF0 , RC_NEUTRAL );
	PWMPulseWidthSet(PF1 , RC_NEUTRAL );
	PWMStart( PWM_GEN_0 );

	SetArmLength( 50.0 , 50.0 );
	new cnt;
	delta1 = 2.5;
	posT[0] = 100.0;		posT[1] = 0.0;
	for(cnt=0; cnt<10; cnt++) {
		posT[0] -= delta1;
		inverseKinematics( posT , angle );
		PWMPulseWidthSet(PF0 , servo_pulse(angle[0]) );
		PWMPulseWidthSet(PF1 , servo_pulse(angle[1]) );
		wait_ms(100);
	}

	GPIOWrite( PG2 , 1 );
	running = true;
	while( running ) {
		if( update ) {
			GPIOWrite( PG2 , ~GPIORead( PG2 ) & 0x1  );
			inverseKinematics( posT , angle );
			PWMPulseWidthSet(PF0 , servo_pulse(angle[0]) );
			PWMPulseWidthSet(PF1 , servo_pulse(angle[1]) );
			Kinematics( angle , posA );
			printf("%f %f \n" ,  posA[0] , posA[1] );
			update = false;
		}
	}
	GPIOWrite( PG2 , 0 );

	delta1 = angle[0]/10.0; 	delta2 = angle[1]/10.0;
	for(cnt=0; cnt<10; cnt++) {
		angle[0] -= delta1; 	angle[1] -= delta2;
		PWMPulseWidthSet(PF0 , servo_pulse(angle[0]) );
		PWMPulseWidthSet(PF1 , servo_pulse(angle[1]) );
		wait_ms(100);
	}
}
