#include "pawn_lm3s3748_IO.h"

#include "inc/hw_gpio.h"
#include "inc/hw_ints.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "inc/hw_adc.h"

#include "driverlib/rom.h"
#include "driverlib/rom_map.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/adc.h"
#include "driverlib/interrupt.h"

#define PAWN_PERIPH_ADC		SYSCTL_PERIPH_ADC0
#define PAWN_ADC_BASE   	ADC0_BASE
#define PAWN_ADC_SeqNo		0
#define ANALOG_IN_MAX		8

unsigned long g_ulADCVal[ANALOG_IN_MAX];				// A/Dϊʊi[z
unsigned char g_NumAnalogIn = 0;						// V[PX
unsigned char g_AdcStepIfo[ANALOG_IN_MAX];				// eXebvŕϊA/D`lԍ
unsigned long g_SamplingRate = SYSCTL_ADCSPEED_125KSPS;	// TvO[g
tBoolean g_ADCConfigured = false;						// ݒ芮tO

int amx_putstr(const char* s);

// ADϊ荞݊֐
void ADCIntHandler()
{
	unsigned long temp[ANALOG_IN_MAX];	// ϊʎ擾pz iTCYőV[PXj
	unsigned char i;

	MAP_ADCIntClear( PAWN_ADC_BASE , PAWN_ADC_SeqNo );	// 荞݂NA

	MAP_ADCSequenceDataGet( PAWN_ADC_BASE , PAWN_ADC_SeqNo , temp );	// ADϊʂ̎擾
	for(i=0 ; i < g_NumAnalogIn ; i++)
	{
		g_ulADCVal[i] = temp[i] ;	// ϊʂ̃Rs[
	}

	MAP_ADCProcessorTrigger( PAWN_ADC_BASE, PAWN_ADC_SeqNo );	// TvV[PX̍ċN
}

// w肵sAiO͂Ƃ
static cell AMX_NATIVE_CALL n_PinTypeAnalogIn(AMX *amx, const cell *params)
{
	unsigned long pf_code = ( unsigned long )params[1];				// IOR[h(1)̎擾
	unsigned char pin_code = ( unsigned char )( pf_code >> 24 );	// IOR[h̏8rbg擾
	unsigned char ucPins;
	unsigned char port_no;
	unsigned char pin_no;
	unsigned long func_code;
	unsigned char ad_ch;
	cell ret = -1;

	if( ( ( pf_code >> 8 ) & 0xFFFF )== 0 ) {	// ɕʂ̋@\蓖ĂĂȂ̃`FbN
		if( g_NumAnalogIn < ANALOG_IN_MAX ) {	// V[PX̃`FbN
			port_no = (pin_code >> 4) & 0x7;	// |[gԍ̎擾
			pin_no = (pin_code & 0x7);			// sԍ̎擾
			
			if( (port_no != PORTD) && (port_no != PORTE) ) {	// PROTD , PORTEȊOw肳ꂽꍇ̓G[
				amx_putstr("Invalid PORT No.\n");
				return ret;
			}

			if ( (pin_no < 4) ) {						// sԍ0`3̏ꍇ̓G[
				amx_putstr("Invalid PIN No.\n");
				return ret;
			}

			func_code = PinFuncAnalogIn | g_NumAnalogIn;	// @\R[h̐ݒ

			if( SetPinFuncCode( amx, pin_code , func_code ) == AMX_ERR_NONE ) {	// IOR[hPawnVM֏߂
				ucPins = ( 1 << pin_no );	// s}XN쐬
				if(port_no == PORTD) {
					MAP_SysCtlPeripheralEnable( SYSCTL_PERIPH_GPIOD );	// PORTDLɂ
					MAP_GPIOPinTypeADC( GPIO_PORTD_BASE , ucPins );		// AiO͂Ƃ
				}
				else {
					MAP_SysCtlPeripheralEnable( SYSCTL_PERIPH_GPIOE );	// PORTELɂ
					MAP_GPIOPinTypeADC( GPIO_PORTE_BASE , ucPins );		// AiO͂Ƃ
				}
				
				ad_ch =  ((port_no ^ 0x4) & 0x4) | ( (~pin_no) & 0x3 );	// ADϊ`lԍ̎w
				g_AdcStepIfo[g_NumAnalogIn] = ad_ch;					// ADϊ`lԍۑ

				ret = (pin_code << 24) | func_code ;					// IOR[h߂l֑
				g_NumAnalogIn++;										// V[PXCNg
			}
		}
	}

	return ret;
}

// ADϊV[PXJn
static cell AMX_NATIVE_CALL n_ADCStart(AMX *amx,const cell *params)
{
	unsigned char i;
	cell ret = -1;

	if( g_NumAnalogIn == 0 ) {
		amx_putstr("SeqLength = 0\r\n");
		return ret;
	}
	if( g_ADCConfigured ) {
		amx_putstr("ADC has already started\r\n");
		return ret;
	}

	MAP_SysCtlPeripheralEnable( PAWN_PERIPH_ADC );	// ADCLɂ

	MAP_SysCtlADCSpeedSet( g_SamplingRate );	// TvO[gݒ
	MAP_ADCSequenceDisable( PAWN_ADC_BASE , PAWN_ADC_SeqNo );	// V[PXUɂ
	// TvV[PX̐ݒigK\[XCDxj
	MAP_ADCSequenceConfigure( PAWN_ADC_BASE , PAWN_ADC_SeqNo , ADC_TRIGGER_PROCESSOR, 0 );

	for(i=0 ; i < g_NumAnalogIn ; i++) {
		unsigned long para = g_AdcStepIfo[i];										// ADϊ̃`lԍݒ
		if (i == (g_NumAnalogIn - 1) ) para |= (ADC_CTL_IE | ADC_CTL_END );			// V[PX̖̐ݒ
		MAP_ADCSequenceStepConfigure( PAWN_ADC_BASE , PAWN_ADC_SeqNo , i, para );	// V[PXEXebv̐ݒ
	}

	MAP_ADCSequenceEnable( PAWN_ADC_BASE , PAWN_ADC_SeqNo );	// V[PXLɂ
	MAP_ADCProcessorTrigger( PAWN_ADC_BASE , PAWN_ADC_SeqNo );	// TvV[PX̋N

	MAP_ADCIntEnable( PAWN_ADC_BASE , PAWN_ADC_SeqNo );			// V[PX荞݂Lɂ
	ADCIntRegister( PAWN_ADC_BASE , PAWN_ADC_SeqNo , ADCIntHandler );	// 荞݊֐̓o^

	g_ADCConfigured = true;		// ADϊV[PXNƂ}[N

	return 1;
}

// ADϊʂǂݎ
static cell AMX_NATIVE_CALL n_ADCRead(AMX *amx,const cell *params)
{
	unsigned long pf_code = ( unsigned long )params[1];	// IOR[h(1)̎擾
	unsigned char step_no;
	cell ret = -1;

	if( !g_ADCConfigured ) {
		amx_putstr("ADC does not start\r\n");
		return ret;
	}

	if( ( pf_code & PinFuncAnalogIn ) == PinFuncAnalogIn ) {	// AnalogIn̏ꍇ
		step_no = pf_code & 0xF;			// Xebvԍ̎擾
		if( step_no < g_NumAnalogIn ) {
			ret = g_ulADCVal[ step_no ];	// ADϊʂ̎擾
		}
	}
	if( ret == (-1) ) amx_putstr("illegal I/O\n");

	return ret;
}

int amx_lm3s3748_ADCInit(AMX *amx)
{
	static AMX_NATIVE_INFO ADC_Extension[] = 
	{
		{ "PinTypeAnalogIn"  , n_PinTypeAnalogIn },
		{ "ADCStart"         , n_ADCStart },
		{ "ADCRead"          , n_ADCRead },
		{ NULL    , NULL }        // terminator
	};

	return amx_Register(amx , ADC_Extension , -1);
}

int amx_lm3s3748_ADCCleanup(AMX *amx)
{
	unsigned char i;
	unsigned char ad_ch;
	tBoolean ResetPortD = false , ResetPortE = false;

	if( g_ADCConfigured ) {											// ADϊV[PXNĂꍇ
		MAP_ADCIntDisable( PAWN_ADC_BASE , PAWN_ADC_SeqNo );		// V[PX荞݂𖳌ɂ
		ADCIntUnregister( PAWN_ADC_BASE , PAWN_ADC_SeqNo );			// 荞݊֐̓o^
		MAP_ADCSequenceDisable( PAWN_ADC_BASE , PAWN_ADC_SeqNo );	// V[PX𖳌ɂ
		MAP_SysCtlPeripheralReset( PAWN_PERIPH_ADC );				// ADCZbg

		for(i=0; i<g_NumAnalogIn; i++) {
			ad_ch = g_AdcStepIfo[i];
			if( ad_ch < 4)	ResetPortE = true;	// GPIO_PORTEgpĂ
			else			ResetPortD = true;	// GPIO_PORTDgpĂ
		}
		if( ResetPortD ) {
//			amx_putstr("reset PORTD\r\n");
			MAP_SysCtlPeripheralReset( SYSCTL_PERIPH_GPIOD );	// GPIO_PORTDZbg
		}
		if( ResetPortE ) {
//			amx_putstr("reset PORTE\r\n");
			MAP_SysCtlPeripheralReset( SYSCTL_PERIPH_GPIOE );	// GPIO_PORTEZbg
		}
	}

	g_SamplingRate = SYSCTL_ADCSPEED_125KSPS;	//	ftHgTvO125Kspsɂ
	g_ADCConfigured = false;
	g_NumAnalogIn  = 0;
	for(i=0 ; i< ANALOG_IN_MAX ; i++) g_ulADCVal[i] = 0;

	return AMX_ERR_NONE;
}
