#include "amx.h"
#include "pawn_lm3s3748_IO.h"

#include "pawn_gpio.h"
#include "pawn_adc.h"
#include "pawn_pwm.h"

int amx_putstr(const char* s);

void PinCodeToVarName( unsigned char pin_code , char* varName )
{
	varName[0] = 'P';
	varName[1] = (pin_code >> 4) + 'A';
	varName[2] = (pin_code & 0xF) + '0';
	varName[3] = '\0';
}

/* CꑤŐݒ肵@\ݒR[hPawnz}ṼpubNϐɏ߂ */
int SetPinFuncCode(AMX *amx, unsigned char pin_code , unsigned long func_code)
{
	char varName[4];
	cell *cPtr , amxPtr;
	int ret = -1;

	PinCodeToVarName( pin_code , varName );		// sf[^s̕쐬

#if defined PAWN4
	// Pawno[W4n̏ꍇ
	if( amx_FindPubVar(amx, varName, (cell **)(&amxPtr)) == AMX_ERR_NONE ) {	// ŝŎw肳pubNϐ̃AhX擾
		cPtr = amx_Address(amx , amxPtr );										// PawnVM̃AhXC̃AhX֕ϊ
		if( cPtr != NULL) {
			*cPtr = (pin_code << 24) | func_code ;								// IOR[h
			ret = AMX_ERR_NONE;
		}
	}
#else
	// o[W4ȑȌꍇ
	if( amx_FindPubVar(amx, varName, &amxPtr) == AMX_ERR_NONE ) {	// ŝŎw肳pubNϐ̃AhX擾
		if( amx_GetAddr(amx, amxPtr, &cPtr)  == AMX_ERR_NONE ) {	// PawnVM̃AhXC̃AhX֕ϊ
			*cPtr = (pin_code << 24) | func_code ;					// IOR[h
			ret = AMX_ERR_NONE;
		}
	}
#endif

	return ret;
}

/* LM3S3748W[̓o^ */
int amx_LM3S3748_IOInit(AMX *amx)
{
	amx_lm3s3748_GPIOInit(amx);		// GPIOW[̓o^
	amx_lm3s3748_ADCInit(amx);		// ADCW[̓o^
	amx_lm3s3748_PWMInit(amx);		// PWMW[̓o^

	return AMX_ERR_NONE;
}

/* LM3S3748W[̔j */
int amx_LM3S3748_IOCleanup(AMX *amx)
{
	amx_lm3s3748_GPIOCleanup(amx);	// GPIOW[̔j
	amx_lm3s3748_ADCCleanup(amx);	// ADCW[̔j
	amx_lm3s3748_PWMCleanup(amx);	// PWMW[̔j

	return AMX_ERR_NONE;
}
