#include "pawn_lm3s3748_IO.h"

#include "inc/hw_ints.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "inc/hw_pwm.h"

#include "driverlib/rom.h"
#include "driverlib/rom_map.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/pwm.h"
#include "driverlib/pin_map.h"
#include "driverlib/interrupt.h"

unsigned long g_ulPulseWidth[8] = { 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 };	// pXf[^
tBoolean g_PWMPinConfigured[8] = { false , false , false , false , false , false , false , false};		// PWM Pin ݒ芮tO
unsigned long g_ulPulsePeriod[4] = { 0 , 0 , 0 , 0 };					// PWM
tBoolean g_PWMGenConfigured[4] = { false , false , false , false };		// PWM Gen ݒ芮tO
unsigned long g_PWMClockDIV = SYSCTL_PWMDIV_16;							// PWMNbN

int amx_putstr(const char* s);

// PWMϊ荞݊֐vg^Cv
void PWM0IntHandler(void);
void PWM1IntHandler(void);
void PWM2IntHandler(void);
void PWM3IntHandler(void);
// 荞݊֐z
void (*PWMIntHandler[])(void) = { PWM0IntHandler , PWM1IntHandler , PWM2IntHandler , PWM3IntHandler };

// w肵sPWMo͂Ƃ
static cell AMX_NATIVE_CALL n_PinTypePWMOut(AMX *amx, const cell *params)
{
	unsigned long pf_code = ( unsigned long )params[1];				// IOR[h(1)̎擾
	unsigned char pin_code = ( unsigned char )( pf_code >> 24 );	// IOR[h̏8rbg擾
	unsigned char ucPins;
	unsigned char port_no;
	unsigned char pin_no;
	unsigned long func_code;
	unsigned char pwm_ch_no , temp;;
	cell ret = -1;

	if( ( ( pf_code >> 8 ) & 0xFFFF )== 0 ) {	// ɕʂ̋@\蓖ĂĂȂ̃`FbN
		port_no = (pin_code >> 4) & 0x7;		// |[gԍ̎擾
		pin_no = (pin_code & 0x7);				// sԍ̎擾
			
		if( (port_no != PORTF) && (port_no != PORTG) ) {	// PORTF , PORTGȊOw肳ꂽꍇ̓G[
			amx_putstr("Invalid PORT No.\n");
			return ret;
		}

		// PWM`lԍ̐ݒ
		if( port_no == PORTF) {
			temp = ( pin_no & 0x4 );	// pin_no  0 or 1 or 2 or 3 ̃`FbN
			if( temp == 0)  pwm_ch_no = pin_no;
			else			pwm_ch_no = 8;
		}
		else {
			temp = (( pin_no & 0x4 ) >> 2) ^ (( pin_no & 0x2 ) >> 1);		// pin_no  0 or 1 or 6 or 7 ̃`FbN
			if( temp == 0)	pwm_ch_no = pin_no | 0x4;
			else 			pwm_ch_no = 8;
		}

		if( pwm_ch_no == 8) {				// sԍs
			amx_putstr("Invalid PIN No.\n");
			return ret;
		}
		
		func_code = PinFuncPWMOut | pwm_ch_no;	// @\R[h̐ݒ
		
		if( SetPinFuncCode( amx, pin_code , func_code ) == AMX_ERR_NONE ) { 	// IOR[hPawnVM֏߂
			ucPins = ( 1 << pin_no );	// s}XN쐬
			if( port_no == PORTF ) {
				MAP_SysCtlPeripheralEnable( SYSCTL_PERIPH_GPIOF );	// PORTFLɂ
				MAP_GPIOPinTypePWM( GPIO_PORTF_BASE , ucPins );		// PWMo͂Ƃ
			}
			else {
				MAP_SysCtlPeripheralEnable( SYSCTL_PERIPH_GPIOG );	// PORTGLɂ
				MAP_GPIOPinTypePWM( GPIO_PORTG_BASE , ucPins );		// PWMo͂Ƃ
			}
			g_PWMPinConfigured[ pwm_ch_no ] = true;					// PWMsݒ芮Ƃۑ

			ret = (pin_code << 24) | func_code ;					// IOR[h߂l֑
		}
	}

	return ret;
}

static cell AMX_NATIVE_CALL n_PWMStart(AMX *amx,const cell *params)
{
	unsigned char gen_no = ( unsigned char )params[1];	// PWMWFl[^ԍ(1)̎擾
	unsigned long ulGenAddr;							// PWMWFl[^ItZbgAhX
	unsigned long ulPWMOut;								// PWMo̓ItZbgAhX
	unsigned long ulPWMOutBits;							// PWMo̓rbg}XN
	unsigned long ulPWMIntMask;							// PWM荞݃rbg}XN
	unsigned char outA , outB;

	cell ret = -1;

	if( gen_no >= 4 ) return ret;			// PWMWFl[^ԍ4ȏ̏ꍇ̓G[

	ulGenAddr = ( (gen_no+1) << 6 );		// PWMWFl[^ItZbgAhXvZ
	outA = ( gen_no << 1 );					// outAPWM`lԍݒ
	outB = outA | 0x1;						// outBPWM`lԍݒ

	if( g_ulPulsePeriod[gen_no] == 0 ) {	// PWMݒ肳ĂȂꍇ̓G[
		amx_putstr("Period = 0\r\n");
		return ret;
	}

	if( ( g_PWMPinConfigured[outA] | g_PWMPinConfigured[outB] ) == false ) {	// ݒς݂PWMo͂ꍇ̓G[
		amx_putstr("No available Pins\r\n");
		return ret;
	}

	MAP_SysCtlPeripheralEnable(SYSCTL_PERIPH_PWM);		// PWMLɂ
	MAP_SysCtlPWMClockSet(g_PWMClockDIV);				// PWMNbNݒ

	// PWMWFl[^JEg_EC񓯊[hŎgp
	MAP_PWMGenConfigure( PWM_BASE, ulGenAddr , PWM_GEN_MODE_DOWN | PWM_GEN_MODE_NO_SYNC);
	MAP_PWMGenPeriodSet( PWM_BASE, ulGenAddr , g_ulPulsePeriod[gen_no] );	// PWMݒ肷

	if( g_PWMPinConfigured[outA] ) {										// outAݒς݂̏ꍇ
		ulPWMOut = ulGenAddr | outA;										// PWMo̓ItZbgAhXvZ
		MAP_PWMPulseWidthSet( PWM_BASE , ulPWMOut , g_ulPulseWidth[outA] );	// outÃpXݒ肷
	}
	if( g_PWMPinConfigured[outB] ) {										// outBݒς݂̏ꍇ
		ulPWMOut = ulGenAddr | outB;										// PWMo̓ItZbgAhXvZ
		MAP_PWMPulseWidthSet( PWM_BASE , ulPWMOut , g_ulPulseWidth[outB] );	// outB̃pXݒ肷
	}

	ulPWMIntMask = (1 << gen_no);
	MAP_PWMIntEnable( PWM_BASE , ulPWMIntMask );	// PWMWFl[^̊荞݂Lɂ
	MAP_PWMGenIntTrigEnable( PWM_BASE , ulGenAddr , PWM_INT_CNT_LOAD);	// PWM荞ݗvCNT_LOADƂ
	PWMGenIntRegister( PWM_BASE , ulGenAddr , PWMIntHandler[gen_no] );	// 荞݊֐̓o^

	if( g_PWMPinConfigured[outA] ) {						// outAݒς݂̏ꍇoutȀo͂
		ulPWMOutBits = (1 << outA);							// PWMo̓rbg}XN𐶐
		MAP_PWMOutputState( PWM_BASE, ulPWMOutBits , true);
	}
	if( g_PWMPinConfigured[outB] ) {						// outBݒς݂̏ꍇoutB̏o͂
		ulPWMOutBits = (1 << outB);							// PWMo̓rbg}XN𐶐
		MAP_PWMOutputState( PWM_BASE, ulPWMOutBits , true);
	}

	MAP_PWMGenEnable( PWM_BASE, ulGenAddr );			// PWMo͂Jn
	
	g_PWMGenConfigured[ gen_no ] = true;	// PWMWFl[^NƂ}[N

	return 1;
}

static cell AMX_NATIVE_CALL n_PWMGenPeriodSet(AMX *amx,const cell *params)
{
	unsigned char gen_no = ( unsigned char )params[1];	// PWMWFl[^ԍ(1)̎擾
	unsigned long period  = ( unsigned long )params[2];	// PWM(2)̎擾
	cell ret = -1;

	if( gen_no > 4 ) return ret;
	if( period == 0 ) return ret;
	
	g_ulPulsePeriod[gen_no] = period;
	if( g_PWMGenConfigured[gen_no] ) {	// PWMݒ肷
		MAP_PWMGenPeriodSet( PWM_BASE, ( (gen_no+1) << 6 ) , g_ulPulsePeriod[gen_no] );
	}

	return period;
}

static cell AMX_NATIVE_CALL n_PWMPulseWidthSet(AMX *amx,const cell *params)
{
	unsigned long pf_code = ( unsigned long )params[1];	// IOR[h(1)̎擾
	unsigned long width  = ( unsigned long )params[2];	// pX(2)̎擾
	unsigned char pwm_ch_no;							// PWM`lԍ
	unsigned char gen_no;								// PWMWFl[^ԍ
	cell ret = -1;

	pwm_ch_no = pf_code & 0x7;			// PWM`lԍ̎擾
	if( !g_PWMPinConfigured[ pwm_ch_no ] ) {
		return ret;
	}
	gen_no = ( pwm_ch_no >> 1) & 0x3;

	// w肳ꂽsPWMOut̏ꍇ́CpXۑ
	if( ( pf_code & PinFuncPWMOut ) == PinFuncPWMOut ) {
		if( width > g_ulPulsePeriod[ gen_no ] ) {
			g_ulPulseWidth[ pwm_ch_no ] = g_ulPulsePeriod[gen_no];
		}
		else {
			g_ulPulseWidth[ pwm_ch_no ] = width;
		}
		ret = g_ulPulseWidth[ pwm_ch_no ];
	}
	if( ret == (-1) ) amx_putstr("illegal I/O\n");

	return ret;
}

void PWMStop(unsigned char gen_no)
{
	unsigned long ulGenAddr;	// PWMWFl[^ItZbgAhX
	unsigned char ch_1 , ch_2;

	ulGenAddr = ( (gen_no+1) << 6 );
	ch_1 = ( gen_no << 1 );
	ch_2 = ch_1 | 0x1;

	// gpĂPWMo͂~
	if( g_PWMPinConfigured[ch_1] ) MAP_PWMOutputState( PWM_BASE,  (1 << ch_1 ) , false);
	if( g_PWMPinConfigured[ch_2] ) MAP_PWMOutputState( PWM_BASE,  (1 << ch_2 ) , false);
			
	MAP_PWMIntDisable( PWM_BASE , (1 << gen_no ) );	// 荞ݖɂ
	MAP_PWMGenIntTrigDisable( PWM_BASE , ulGenAddr , PWM_INT_CNT_LOAD);
	PWMGenIntUnregister( PWM_BASE , ulGenAddr ) ;	// 荞݊֐̓o^
	MAP_PWMGenDisable( PWM_BASE, ulGenAddr );		// PWMWFl[^~
}

int amx_lm3s3748_PWMInit(AMX *amx)
{
	static AMX_NATIVE_INFO PWM_Extension[] = 
	{
		{ "PinTypePWMOut"    , n_PinTypePWMOut },
		{ "PWMGenPeriodSet"  , n_PWMGenPeriodSet },
		{ "PWMPulseWidthSet" , n_PWMPulseWidthSet },
		{ "PWMStart"         , n_PWMStart },
		{ NULL    , NULL }        // terminator
	};

	return amx_Register(amx , PWM_Extension , -1);
}

int amx_lm3s3748_PWMCleanup(AMX *amx)
{
	unsigned char i;

	for(i=0 ; i< 4 ; i++) {
		if( g_PWMGenConfigured[i] ) {		// NĂPWMWFl[^
			PWMStop(i);						// ~
		}
		g_ulPulsePeriod[i] = 0;
		g_PWMGenConfigured[i] = false;
	}
	
	if( g_PWMPinConfigured[0] | g_PWMPinConfigured[1] |  g_PWMPinConfigured[2]  | g_PWMPinConfigured[3] ) {
//			amx_putstr("reset PORTF\r\n");
			MAP_SysCtlPeripheralReset( SYSCTL_PERIPH_GPIOF );	// GPIO_PORTFZbg
	}
	if( g_PWMPinConfigured[4] | g_PWMPinConfigured[5] |  g_PWMPinConfigured[6]  | g_PWMPinConfigured[7] ) {
//			amx_putstr("reset PORTG\r\n");
			MAP_SysCtlPeripheralReset( SYSCTL_PERIPH_GPIOG );	// GPIO_PORTGZbg
	}
	
	for(i=0 ; i< 8 ; i++) {
		g_ulPulseWidth[i] = 0;
		g_PWMPinConfigured[i] = false;
	}

	g_PWMClockDIV = SYSCTL_PWMDIV_16;	//	ftHgPWMNbN16Ƃ

	return AMX_ERR_NONE;
}

// PWM0荞݊֐
void PWM0IntHandler(void)
{
    MAP_PWMGenIntClear(PWM_BASE, PWM_GEN_0, PWM_INT_CNT_LOAD);			// 荞݂NA

	if( g_PWMPinConfigured[0] ) {										// CH0ANeBuȏꍇ
		MAP_PWMPulseWidthSet(PWM_BASE, PWM_OUT_0, g_ulPulseWidth[0] );	// CH0̃pXXV
	}
	if( g_PWMPinConfigured[1] ) {										// CH1ANeBuȏꍇ
		MAP_PWMPulseWidthSet(PWM_BASE, PWM_OUT_1, g_ulPulseWidth[1] );	// CH1̃pXXV
	}
}

// PWM1荞݊֐
void PWM1IntHandler(void)
{
    MAP_PWMGenIntClear(PWM_BASE, PWM_GEN_1, PWM_INT_CNT_LOAD);			// 荞݂NA

	if( g_PWMPinConfigured[2] ) {										// CH2ANeBuȏꍇ
		MAP_PWMPulseWidthSet(PWM_BASE, PWM_OUT_2, g_ulPulseWidth[2] );	// CH2̃pXXV
	}
	if( g_PWMPinConfigured[3] ) {										// CH3ANeBuȏꍇ
		MAP_PWMPulseWidthSet(PWM_BASE, PWM_OUT_3, g_ulPulseWidth[3] );	// CH3̃pXXV
	}
}

// PWM2荞݊֐
void PWM2IntHandler(void)
{
    MAP_PWMGenIntClear(PWM_BASE, PWM_GEN_2, PWM_INT_CNT_LOAD);			// 荞݂NA

	if( g_PWMPinConfigured[4] ) {										// CH4ANeBuȏꍇ
		MAP_PWMPulseWidthSet(PWM_BASE, PWM_OUT_4, g_ulPulseWidth[4] );	// CH4̃pXXV
	}
	if( g_PWMPinConfigured[5] ) {										// CH5ANeBuȏꍇ
		MAP_PWMPulseWidthSet(PWM_BASE, PWM_OUT_5, g_ulPulseWidth[5] );	// CH5̃pXXV
	}
}

// PWM3荞݊֐
void PWM3IntHandler(void)
{
    MAP_PWMGenIntClear(PWM_BASE, PWM_GEN_3, PWM_INT_CNT_LOAD);			// 荞݂NA

	if( g_PWMPinConfigured[6] ) {										// CH6ANeBuȏꍇ
		MAP_PWMPulseWidthSet(PWM_BASE, PWM_OUT_6, g_ulPulseWidth[6] );	// CH6̃pXXV
	}
	if( g_PWMPinConfigured[7] ) {										// CH7ANeBuȏꍇ
		MAP_PWMPulseWidthSet(PWM_BASE, PWM_OUT_7, g_ulPulseWidth[7] );	// CH7̃pXXV
	}
}
